package vishnu.testvis.dendro;

import java.util.*;

public class Cluster
{
    public int _id;
    public Cluster  _parent = null;
    public Cluster  _child_1 = null;
    public Cluster  _child_2 = null;
    public Vector docVect;
    public Vector docObjVect;
    public int[] wordFreq;  	
    
    public double _children_sim;
    
    // probably the size of the cluster
    public int _items;
    
    public int _split;
    
    
    
    // [] -> centroid for each vector element ?
    public double[] _centroid=null;
    
    public Vector _iter_items = null;
    public int _iter_items_num = 0;
    
    public int _x = 0;
    public int _y = 0;
    public double[] getCentroid(){return _centroid;}
    
    public Cluster(int id, Cluster parent, Cluster child_1, Cluster child_2, double children_sim, int items)
    {
	_id                    = id;
	_children_sim          = children_sim;
	_items                 = items;
	_split                 = 0;
	_parent                = parent;
        _iter_items            = new Vector(0);
        
        // probably to get a balanced tree
	if (child_1 != null && child_2 != null)
	    {
		if (child_2._items > child_1._items)
		    {
		        _child_1 = child_1;
		        _child_2 = child_2;
		    }
    		else
		    {
		        _child_1 = child_2;
		        _child_2 = child_1;
		    }
  	    }
	else // if either or both are null
	    {
    		_child_1 = child_1;
    		_child_2 = child_2;
	    }
    }
    
    public void setDocVect(Vector docs)
    {
	docVect = docs;
    }
    
    public void setDocObjVect(Vector docObj)
    {
	docObjVect = docObj;
    }
    
    public Vector getDocObjVect()
    {
	return docObjVect;
    }
    
    public Vector getDocVect()
    {
	return docVect;
    }
    
    public void setWordFreq(int[] freqs)
    {
	wordFreq = freqs;
    }
    
    public int[] getWordFreq()
    {
	return wordFreq;
    }
    
    // a nice recursive function to determine the depth of the hierarchy
    public int depth()
    {
	if (_id != -1)
	    return 0;
	else
    		return Math.max(1 + _child_1.depth(), 1 + _child_2.depth());
	}

    void addChildrenToOutputVector(int []coding, Vector output)
	{
  	  if (_id != -1)
          {
    	    Integer ii = new Integer(coding[_id]);
            output.addElement(ii);

          }
  	  else
    	  {
      	    _child_1.addChildrenToOutputVector(coding,output);
      	    _child_2.addChildrenToOutputVector(coding,output);
    	  }
    }

}


